Classes | Public Types | Public Member Functions | Public Attributes | Private Member Functions | List of all members
libebook::XMLTreeNode Struct Reference

`#include <XMLTreeNode.h>`

## Classes
struct | AttributeData
struct | Configuration
struct | ElementData
struct | QName

## Public Types
enum | NodeType { NODE_TYPE_DOCUMENT = 1 << 1, NODE_TYPE_ELEMENT = 1 << 2, NODE_TYPE_TEXT = 1 << 3, NODE_TYPE_COMMENT = 1 << 4, NODE_TYPE_DOCTYPE = 1 << 5 }
typedef std::pair< QName, QName > | LinkId_t
typedef boost::shared_ptr< Configuration > | ConfigurationPtr_t

## Public Member Functions
| XMLTreeNode (NodeType nodeType, const ConfigurationPtr_t &config=ConfigurationPtr_t())
| ~XMLTreeNode ()
XMLTreeNodePtr_t | clone (bool deep=false) const
XMLTreeNodePtr_t | appendChild (const XMLTreeNodePtr_t &child)
XMLTreeNodePtr_t | insertChildBefore (const XMLTreeNodePtr_t &child, const XMLTreeNodePtr_t &selected)
void | removeChild (const XMLTreeNodePtr_t &child)
void | transferChildren (const XMLTreeNodePtr_t &newParent)
void | addAttributes (const std::deque< AttributeData > &attrs)
bool | hasChildren (bool ignoreText=false) const

## Public Attributes
NodeType | type
ConfigurationPtr_t | configuration
ElementData | self
std::deque< AttributeData > | attributes
std::string | text
XMLTreeNodePtr_t | parent
XMLTreeNodePtr_t | prev
XMLTreeNodePtr_t | next
XMLTreeNodePtr_t | first
XMLTreeNodePtr_t | last
size_t | elements
int | refcount

## Private Member Functions
| XMLTreeNode (const XMLTreeNode &)
XMLTreeNode & | operator= (const XMLTreeNode &)

## Member Typedef Documentation

## § ConfigurationPtr_t

typedef boost::shared_ptr<Configuration> libebook::XMLTreeNode::ConfigurationPtr_t

## § LinkId_t

typedef std::pair<QName, QName> libebook::XMLTreeNode::LinkId_t

## Member Enumeration Documentation

## § NodeType

enum libebook::XMLTreeNode::NodeType

Enumerator
NODE_TYPE_DOCUMENT |
NODE_TYPE_ELEMENT |
NODE_TYPE_TEXT |
NODE_TYPE_COMMENT |
NODE_TYPE_DOCTYPE |

## Constructor & Destructor Documentation

## § XMLTreeNode() [1/2]

libebook::XMLTreeNode::XMLTreeNode | ( | NodeType | nodeType,
|  | const ConfigurationPtr_t & | config = `ConfigurationPtr_t()`
| ) |  |
| explicit

## § ~XMLTreeNode()

libebook::XMLTreeNode::~XMLTreeNode | ( |  | ) |

## § XMLTreeNode() [2/2]

libebook::XMLTreeNode::XMLTreeNode | ( | const XMLTreeNode & |  | ) |
| private

## Member Function Documentation

## § addAttributes()

void libebook::XMLTreeNode::addAttributes | ( | const std::deque< AttributeData > & | attrs | ) |

## § appendChild()

XMLTreeNodePtr_t libebook::XMLTreeNode::appendChild | ( | const XMLTreeNodePtr_t & | child | ) |

## § clone()

XMLTreeNodePtr_t libebook::XMLTreeNode::clone | ( | bool | deep = `false` | ) | const

## § hasChildren()

bool libebook::XMLTreeNode::hasChildren | ( | bool | ignoreText = `false` | ) | const

## § insertChildBefore()

XMLTreeNodePtr_t libebook::XMLTreeNode::insertChildBefore | ( | const XMLTreeNodePtr_t & | child,
|  | const XMLTreeNodePtr_t & | selected
| ) |  |

## § operator=()

XMLTreeNode& libebook::XMLTreeNode::operator= | ( | const XMLTreeNode & |  | ) |
| private

## § removeChild()

void libebook::XMLTreeNode::removeChild | ( | const XMLTreeNodePtr_t & | child | ) |

## § transferChildren()

void libebook::XMLTreeNode::transferChildren | ( | const XMLTreeNodePtr_t & | newParent | ) |

## Member Data Documentation

## § attributes

std::deque<AttributeData> libebook::XMLTreeNode::attributes

## § configuration

ConfigurationPtr_t libebook::XMLTreeNode::configuration

## § elements

size_t libebook::XMLTreeNode::elements

## § first

XMLTreeNodePtr_t libebook::XMLTreeNode::first

## § last

XMLTreeNodePtr_t libebook::XMLTreeNode::last

## § next

XMLTreeNodePtr_t libebook::XMLTreeNode::next

## § parent

XMLTreeNodePtr_t libebook::XMLTreeNode::parent

## § prev

XMLTreeNodePtr_t libebook::XMLTreeNode::prev

## § refcount

int libebook::XMLTreeNode::refcount
| mutable

Referenced by libebook::intrusive_ptr_add_ref(), and libebook::intrusive_ptr_release().

## § self

ElementData libebook::XMLTreeNode::self

## § text

std::string libebook::XMLTreeNode::text

## § type

NodeType libebook::XMLTreeNode::type

Referenced by ~XMLTreeNode().

The documentation for this struct was generated from the following files:

- XMLTreeNode.h
- XMLTreeNode.cpp